# PrestaShop\Module\PrestaConnector\pol\api\lib\StocksApi

All URIs are relative to https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api/WebConnect, except if the operation defines another base path.

| Method | HTTP request | Description |
| ------------- | ------------- | ------------- |
| [**stocksGetCommandes()**](StocksApi.md#stocksGetCommandes) | **GET** /Stocks/Commandes | Obtient les commandes en cours. ATTENTION : les données de L&#39;API ne font ressortir que les quantités en commandes supérieures à zéro. Donc quand un article n&#39;est plus en commande les données n&#39;existent pas dans le JSON de retour |
| [**stocksGetDetailsPromotions()**](StocksApi.md#stocksGetDetailsPromotions) | **GET** /Stocks/DetailsPromotions | Obtient les détails des plans de promotions. |
| [**stocksGetPromotions()**](StocksApi.md#stocksGetPromotions) | **GET** /Stocks/Promotions | Obtient les promotions en cours et à venir |
| [**stocksGetStocks()**](StocksApi.md#stocksGetStocks) | **GET** /Stocks/Stocks | Obtient les changements de stocks et de prix. |
| [**stocksGetTransfert()**](StocksApi.md#stocksGetTransfert) | **GET** /Stocks/Transfert | Contrôler un mouvement de stock |
| [**stocksGetVenteEnGros()**](StocksApi.md#stocksGetVenteEnGros) | **GET** /Stocks/VenteEnGros | Contrôler une vente en gros |
| [**stocksPostConfirmationTransfert()**](StocksApi.md#stocksPostConfirmationTransfert) | **POST** /Stocks/ConfirmationTransfert | Indique la confirmation d&#39;un transfert ou d&#39;une commande interne |
| [**stocksPostTransfert()**](StocksApi.md#stocksPostTransfert) | **POST** /Stocks/Transfert | Créer un mouvement de stock en deux magasins |
| [**stocksPostVenteEnGros()**](StocksApi.md#stocksPostVenteEnGros) | **POST** /Stocks/VenteEnGros | Créer d&#39;une vente en gros |


## `stocksGetCommandes()`

```php
stocksGetCommandes($filtre_produit, $derniere_modification, $pager): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultReleveCde
```

Obtient les commandes en cours. ATTENTION : les données de L'API ne font ressortir que les quantités en commandes supérieures à zéro. Donc quand un article n'est plus en commande les données n'existent pas dans le JSON de retour

Obtient les commandes en cours. ATTENTION : les données de L'API ne font ressortir que les quantités en commandes supérieures à zéro. Donc quand un article n'est plus en commande les données n'existent pas dans le JSON de retour

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\StocksApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$filtre_produit = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\FiltreProduit(); // FiltreProduit | Si précisé, ne renvoi que les articles des produits correspondants au filtrage
$derniere_modification = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | Si précisé, ne renvoi que le relevé de stock des articles dont le stock ou le prix ou une promotion attachée à ce produit a changé depuis la date précisée
$pager = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\Pager(); // Pager | Configuration de la sortie d'un résultat      Une documentation complémentaire est disponible à l'adresse [/api?doc=WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc=WebConnect.Pager)

try {
    $result = $apiInstance->stocksGetCommandes($filtre_produit, $derniere_modification, $pager);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StocksApi->stocksGetCommandes: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **filtre_produit** | [**FiltreProduit**](../Model/.md)| Si précisé, ne renvoi que les articles des produits correspondants au filtrage | [optional] |
| **derniere_modification** | **\DateTime**| Si précisé, ne renvoi que le relevé de stock des articles dont le stock ou le prix ou une promotion attachée à ce produit a changé depuis la date précisée | [optional] |
| **pager** | [**Pager**](../Model/.md)| Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) | [optional] |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultReleveCde**](../Model/PagedResultReleveCde.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `stocksGetDetailsPromotions()`

```php
stocksGetDetailsPromotions($derniere_modification, $only_active, $code_promotion, $filtre_produit, $pager): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultDetailPromotion
```

Obtient les détails des plans de promotions.

Obtient les détails des plans de promotions.

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\StocksApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$derniere_modification = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | Si précisé, ne renvoi que les détails ayant changés depuis cette date
$only_active = true; // bool | Si vrai, ne renvoi que les promotions en cours et futures
$code_promotion = 'code_promotion_example'; // string | Si précisé, ne renvoi que les détails correspondant à la promotion spécifiée par son code
$filtre_produit = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\FiltreProduit(); // FiltreProduit | Si précisé, ne renvoi que les détails correspondant aux produits (déclinaisons) sélectionnés
$pager = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\Pager(); // Pager | Configuration de la sortie d'un résultat      Une documentation complémentaire est disponible à l'adresse [/api?doc=WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc=WebConnect.Pager)

try {
    $result = $apiInstance->stocksGetDetailsPromotions($derniere_modification, $only_active, $code_promotion, $filtre_produit, $pager);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StocksApi->stocksGetDetailsPromotions: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **derniere_modification** | **\DateTime**| Si précisé, ne renvoi que les détails ayant changés depuis cette date | [optional] |
| **only_active** | **bool**| Si vrai, ne renvoi que les promotions en cours et futures | [optional] [default to true] |
| **code_promotion** | **string**| Si précisé, ne renvoi que les détails correspondant à la promotion spécifiée par son code | [optional] |
| **filtre_produit** | [**FiltreProduit**](../Model/.md)| Si précisé, ne renvoi que les détails correspondant aux produits (déclinaisons) sélectionnés | [optional] |
| **pager** | [**Pager**](../Model/.md)| Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) | [optional] |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultDetailPromotion**](../Model/PagedResultDetailPromotion.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `stocksGetPromotions()`

```php
stocksGetPromotions($derniere_modification, $only_active, $pager): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultPromotion
```

Obtient les promotions en cours et à venir

Obtient les promotions en cours et à venir

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\StocksApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$derniere_modification = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | Si précisé, ne renvoi que les promotions ayant changées depuis cette date
$only_active = true; // bool | Si vrai, ne renvoi que les promotions en cours et futures
$pager = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\Pager(); // Pager | Configuration de la sortie d'un résultat      Une documentation complémentaire est disponible à l'adresse [/api?doc=WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc=WebConnect.Pager)

try {
    $result = $apiInstance->stocksGetPromotions($derniere_modification, $only_active, $pager);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StocksApi->stocksGetPromotions: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **derniere_modification** | **\DateTime**| Si précisé, ne renvoi que les promotions ayant changées depuis cette date | [optional] |
| **only_active** | **bool**| Si vrai, ne renvoi que les promotions en cours et futures | [optional] [default to true] |
| **pager** | [**Pager**](../Model/.md)| Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) | [optional] |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultPromotion**](../Model/PagedResultPromotion.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `stocksGetStocks()`

```php
stocksGetStocks($filtre_produit, $derniere_modification, $pager, $date_solde, $is_solde, $is_promo, $is_internet, $is_magasin, $code_promo): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultReleveStock
```

Obtient les changements de stocks et de prix.

Obtient les changements de stocks et de prix.

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\StocksApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$filtre_produit = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\FiltreProduit(); // FiltreProduit | Si précisé, ne renvoi que les articles des produits correspondants au filtrage
$derniere_modification = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | Si précisé, ne renvoi que le relevé de stock des articles dont le stock ou le prix ou une promotion attachée à ce produit a changé depuis la date précisée
$pager = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\Pager(); // Pager | Configuration de la sortie d'un résultat      Une documentation complémentaire est disponible à l'adresse [/api?doc=WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc=WebConnect.Pager)
$date_solde = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | Date de prise en compte des plans de promotion ou de solde, par défaut la date de jour est utilisé
$is_solde = true; // bool | Le plan est en plan de solde
$is_promo = true; // bool | Le plan est en plan de promotions
$is_internet = true; // bool | Le plan est valable sur internet
$is_magasin = true; // bool | Le plan est valable en boutique
$code_promo = 'code_promo_example'; // string | Code du plan

try {
    $result = $apiInstance->stocksGetStocks($filtre_produit, $derniere_modification, $pager, $date_solde, $is_solde, $is_promo, $is_internet, $is_magasin, $code_promo);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StocksApi->stocksGetStocks: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **filtre_produit** | [**FiltreProduit**](../Model/.md)| Si précisé, ne renvoi que les articles des produits correspondants au filtrage | [optional] |
| **derniere_modification** | **\DateTime**| Si précisé, ne renvoi que le relevé de stock des articles dont le stock ou le prix ou une promotion attachée à ce produit a changé depuis la date précisée | [optional] |
| **pager** | [**Pager**](../Model/.md)| Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) | [optional] |
| **date_solde** | **\DateTime**| Date de prise en compte des plans de promotion ou de solde, par défaut la date de jour est utilisé | [optional] |
| **is_solde** | **bool**| Le plan est en plan de solde | [optional] [default to true] |
| **is_promo** | **bool**| Le plan est en plan de promotions | [optional] [default to true] |
| **is_internet** | **bool**| Le plan est valable sur internet | [optional] [default to true] |
| **is_magasin** | **bool**| Le plan est valable en boutique | [optional] [default to true] |
| **code_promo** | **string**| Code du plan | [optional] |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultReleveStock**](../Model/PagedResultReleveStock.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `stocksGetTransfert()`

```php
stocksGetTransfert($ref_transfert): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert
```

Contrôler un mouvement de stock

Contrôler un mouvement de stock

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\StocksApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$ref_transfert = 'ref_transfert_example'; // string | Référence unique du transfert

try {
    $result = $apiInstance->stocksGetTransfert($ref_transfert);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StocksApi->stocksGetTransfert: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **ref_transfert** | **string**| Référence unique du transfert | |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert**](../Model/MetierMvtWebConnectTransfert.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `stocksGetVenteEnGros()`

```php
stocksGetVenteEnGros($ref_transfert): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros
```

Contrôler une vente en gros

Contrôler une vente en gros

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\StocksApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$ref_transfert = 'ref_transfert_example'; // string | Référence unique du transfert

try {
    $result = $apiInstance->stocksGetVenteEnGros($ref_transfert);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StocksApi->stocksGetVenteEnGros: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **ref_transfert** | **string**| Référence unique du transfert | |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros**](../Model/MetierMvtWebConnectVenteEnGros.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `stocksPostConfirmationTransfert()`

```php
stocksPostConfirmationTransfert($metier_mvt_web_connect_confirmation_transfert_creation, $terminer_transfert): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreationReponse
```

Indique la confirmation d'un transfert ou d'une commande interne

Indique la confirmation d'un transfert ou d'une commande interne

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\StocksApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$metier_mvt_web_connect_confirmation_transfert_creation = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreation(); // \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreation | Description de la confirmation de transfert de marchandise  (transfert)
$terminer_transfert = true; // bool | Précise que la commande est finie et que toutes les quantités non confirmées doivent être annulées ou refusées

try {
    $result = $apiInstance->stocksPostConfirmationTransfert($metier_mvt_web_connect_confirmation_transfert_creation, $terminer_transfert);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StocksApi->stocksPostConfirmationTransfert: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **metier_mvt_web_connect_confirmation_transfert_creation** | [**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreation**](../Model/MetierMvtWebConnectConfirmationTransfertCreation.md)| Description de la confirmation de transfert de marchandise  (transfert) | |
| **terminer_transfert** | **bool**| Précise que la commande est finie et que toutes les quantités non confirmées doivent être annulées ou refusées | [optional] [default to true] |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectConfirmationTransfertCreationReponse**](../Model/MetierMvtWebConnectConfirmationTransfertCreationReponse.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: `application/json`
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `stocksPostTransfert()`

```php
stocksPostTransfert($metier_mvt_web_connect_transfert_creation): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert
```

Créer un mouvement de stock en deux magasins

Créer un mouvement de stock en deux magasins

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\StocksApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$metier_mvt_web_connect_transfert_creation = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfertCreation(); // \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfertCreation | Description du transfert de marchandise  (transfert)

try {
    $result = $apiInstance->stocksPostTransfert($metier_mvt_web_connect_transfert_creation);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StocksApi->stocksPostTransfert: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **metier_mvt_web_connect_transfert_creation** | [**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfertCreation**](../Model/MetierMvtWebConnectTransfertCreation.md)| Description du transfert de marchandise  (transfert) | |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectTransfert**](../Model/MetierMvtWebConnectTransfert.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: `application/json`
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `stocksPostVenteEnGros()`

```php
stocksPostVenteEnGros($metier_mvt_web_connect_vente_en_gros_creation): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros
```

Créer d'une vente en gros

Créer d'une vente en gros

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\StocksApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$metier_mvt_web_connect_vente_en_gros_creation = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGrosCreation(); // \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGrosCreation | Description du transfert de marchandise  (venteEnGros)

try {
    $result = $apiInstance->stocksPostVenteEnGros($metier_mvt_web_connect_vente_en_gros_creation);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StocksApi->stocksPostVenteEnGros: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **metier_mvt_web_connect_vente_en_gros_creation** | [**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGrosCreation**](../Model/MetierMvtWebConnectVenteEnGrosCreation.md)| Description du transfert de marchandise  (venteEnGros) | |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierMvtWebConnectVenteEnGros**](../Model/MetierMvtWebConnectVenteEnGros.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: `application/json`
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)
