# PrestaShop\Module\PrestaConnector\pol\api\lib\VentesApi

All URIs are relative to https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api/WebConnect, except if the operation defines another base path.

| Method | HTTP request | Description |
| ------------- | ------------- | ------------- |
| [**ventesDeleteReservation()**](VentesApi.md#ventesDeleteReservation) | **DELETE** /Ventes/Reservation | Annule une réservation |
| [**ventesGetReservations()**](VentesApi.md#ventesGetReservations) | **GET** /Ventes/Reservations | Obtenir les réservations du système |
| [**ventesGetVentes()**](VentesApi.md#ventesGetVentes) | **GET** /Ventes/Ventes | Liste les ventes |
| [**ventesPostReservation()**](VentesApi.md#ventesPostReservation) | **POST** /Ventes/Reservation | Crée une nouvelle réservation |
| [**ventesPostReservationPrepaiement()**](VentesApi.md#ventesPostReservationPrepaiement) | **POST** /Ventes/ReservationPrepaiement | Prépaye une réservation |
| [**ventesPostVente()**](VentesApi.md#ventesPostVente) | **POST** /Ventes/Vente | Crée une nouvelle vente sur le système |


## `ventesDeleteReservation()`

```php
ventesDeleteReservation($code_reservation): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\WebConnectReservation
```

Annule une réservation

Annule une réservation

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\VentesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$code_reservation = 'code_reservation_example'; // string | Code de la réservation à annuler

try {
    $result = $apiInstance->ventesDeleteReservation($code_reservation);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling VentesApi->ventesDeleteReservation: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **code_reservation** | **string**| Code de la réservation à annuler | |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\WebConnectReservation**](../Model/WebConnectReservation.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `ventesGetReservations()`

```php
ventesGetReservations($filtre_reservations, $pager): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultWebConnectReservation
```

Obtenir les réservations du système

Obtenir les réservations du système

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\VentesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$filtre_reservations = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\WebConnectFiltreReservation(); // WebConnectFiltreReservation | Si précisé, ne renvoi que les réservations correspondantes au filtrage
$pager = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\Pager(); // Pager | Configuration de la sortie d'un résultat      Une documentation complémentaire est disponible à l'adresse [/api?doc=WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc=WebConnect.Pager)

try {
    $result = $apiInstance->ventesGetReservations($filtre_reservations, $pager);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling VentesApi->ventesGetReservations: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **filtre_reservations** | [**WebConnectFiltreReservation**](../Model/.md)| Si précisé, ne renvoi que les réservations correspondantes au filtrage | [optional] |
| **pager** | [**Pager**](../Model/.md)| Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) | [optional] |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultWebConnectReservation**](../Model/PagedResultWebConnectReservation.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `ventesGetVentes()`

```php
ventesGetVentes($filtre_client, $depuis_derniere_modification, $pager): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultMetierClientWebConnextTicket
```

Liste les ventes

Liste les ventes

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\VentesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$filtre_client = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierClientWebConnectFiltreClientVente(); // MetierClientWebConnectFiltreClientVente | Si précisé, ne renvoi que les ventes correspondantes au filtrage
$depuis_derniere_modification = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | Si précisé, ne renvoi que le relevé de ventes qui ont changé depuis la date précisée
$pager = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\Pager(); // Pager | Configuration de la sortie d'un résultat      Une documentation complémentaire est disponible à l'adresse [/api?doc=WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc=WebConnect.Pager)

try {
    $result = $apiInstance->ventesGetVentes($filtre_client, $depuis_derniere_modification, $pager);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling VentesApi->ventesGetVentes: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **filtre_client** | [**MetierClientWebConnectFiltreClientVente**](../Model/.md)| Si précisé, ne renvoi que les ventes correspondantes au filtrage | [optional] |
| **depuis_derniere_modification** | **\DateTime**| Si précisé, ne renvoi que le relevé de ventes qui ont changé depuis la date précisée | [optional] |
| **pager** | [**Pager**](../Model/.md)| Configuration de la sortie d&#39;un résultat      Une documentation complémentaire est disponible à l&#39;adresse [/api?doc&#x3D;WebConnect.Pager](https://nur1.pl-vega-0001.polarisgestionmag.net:3443/api?doc&#x3D;WebConnect.Pager) | [optional] |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\PagedResultMetierClientWebConnextTicket**](../Model/PagedResultMetierClientWebConnextTicket.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `ventesPostReservation()`

```php
ventesPostReservation($web_connect_reservation_creation): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\WebConnectReservation
```

Crée une nouvelle réservation

Crée une nouvelle réservation

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\VentesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$web_connect_reservation_creation = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\WebConnectReservationCreation(); // \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\WebConnectReservationCreation | Description de la réservation à créer  (reservation)

try {
    $result = $apiInstance->ventesPostReservation($web_connect_reservation_creation);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling VentesApi->ventesPostReservation: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **web_connect_reservation_creation** | [**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\WebConnectReservationCreation**](../Model/WebConnectReservationCreation.md)| Description de la réservation à créer  (reservation) | |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\WebConnectReservation**](../Model/WebConnectReservation.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: `application/json`
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `ventesPostReservationPrepaiement()`

```php
ventesPostReservationPrepaiement($code_reservation, $web_connect_reservation_paiements): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\WebConnectReservation
```

Prépaye une réservation

Prépaye une réservation

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\VentesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$code_reservation = 'code_reservation_example'; // string | Code de la réservation à prépayer
$web_connect_reservation_paiements = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\WebConnectReservationPaiements(); // \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\WebConnectReservationPaiements | Paiements  (paiements)

try {
    $result = $apiInstance->ventesPostReservationPrepaiement($code_reservation, $web_connect_reservation_paiements);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling VentesApi->ventesPostReservationPrepaiement: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **code_reservation** | **string**| Code de la réservation à prépayer | |
| **web_connect_reservation_paiements** | [**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\WebConnectReservationPaiements**](../Model/WebConnectReservationPaiements.md)| Paiements  (paiements) | |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\WebConnectReservation**](../Model/WebConnectReservation.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: `application/json`
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)

## `ventesPostVente()`

```php
ventesPostVente($metier_debit_web_connect_vente_updateable, $brouillon): \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierDebitWebConnectVente
```

Crée une nouvelle vente sur le système

Crée une nouvelle vente sur le système

### Example

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');


// Configure API key authorization: Secret
$config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKey('X-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = PrestaShop\Module\PrestaConnector\pol\api\lib\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-Key', 'Bearer');


$apiInstance = new PrestaShop\Module\PrestaConnector\pol\api\lib\Api\VentesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$metier_debit_web_connect_vente_updateable = new \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierDebitWebConnectVenteUpdateable(); // \PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierDebitWebConnectVenteUpdateable | Vente à créer  (vente)
$brouillon = false; // bool | Demander à Polaris de calcul les prix, remise, la fidélité...

try {
    $result = $apiInstance->ventesPostVente($metier_debit_web_connect_vente_updateable, $brouillon);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling VentesApi->ventesPostVente: ', $e->getMessage(), PHP_EOL;
}
```

### Parameters

| Name | Type | Description  | Notes |
| ------------- | ------------- | ------------- | ------------- |
| **metier_debit_web_connect_vente_updateable** | [**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierDebitWebConnectVenteUpdateable**](../Model/MetierDebitWebConnectVenteUpdateable.md)| Vente à créer  (vente) | |
| **brouillon** | **bool**| Demander à Polaris de calcul les prix, remise, la fidélité... | [optional] [default to false] |

### Return type

[**\PrestaShop\Module\PrestaConnector\pol\api\lib\Model\MetierDebitWebConnectVente**](../Model/MetierDebitWebConnectVente.md)

### Authorization

[Secret](../../README.md#Secret)

### HTTP request headers

- **Content-Type**: `application/json`
- **Accept**: `application/json`

[[Back to top]](#) [[Back to API list]](../../README.md#endpoints)
[[Back to Model list]](../../README.md#models)
[[Back to README]](../../README.md)
